--
-- Code for creating the MySQL database
--
-- $Id: db.sql,v 1.6 2011/09/17 09:22:11 dds Exp $
--
-- Copyright (c) 2008-2011, Diomidis Spinellis
-- All rights reserved.
--
-- Redistribution and use in source and binary forms, with or without
-- modification, are permitted provided that the following conditions
-- are met:
-- 1. Redistributions of source code must retain the above copyright
--    notice, this list of conditions and the following disclaimer.
-- 2. Redistributions in binary form must reproduce the above copyright
--    notice, this list of conditions and the following disclaimer in the
--    documentation and/or other materials provided with the distribution.
--
-- THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-- ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-- IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-- ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
-- FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-- DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-- OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-- HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-- LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-- OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-- SUCH DAMAGE.
--

drop database if exists poll;
create database poll;
use poll;

CREATE TABLE Polls(
id mediumint not null auto_increment primary key,
question TEXT,
comment TEXT,
users TEXT,
posted DateTime,
tstart DateTime,
tend DateTime
);

CREATE TABLE Options(
id mediumint not null auto_increment primary key,
ordinal smallint,
pollId mediumint,
answer text,
foreign key(pollId) references Polls(id)
);

CREATE TABLE Votes(
name varchar(255),
pollId mediumint,
ip varchar(80),
timestamp DateTime,
foreign key(pollId) references Polls(id),
primary key(name, pollId)
);

CREATE TABLE Tallies(
optionId mediumint not null auto_increment primary key,
count mediumint,
foreign key(optionId) references Options(id)
);

create user 'poll_admin'@'localhost' identified by 'SECRET'; -- FIXME
grant insert on poll.Polls to 'poll_admin'@'localhost';
grant insert on poll.Options to 'poll_admin'@'localhost';
grant insert on poll.Tallies to 'poll_admin'@'localhost';

create user 'poll_vote'@'localhost' identified by 'SECRET'; -- FIXME
grant select, insert on poll.Votes to 'poll_vote'@'localhost';
grant select, update on poll.Tallies to 'poll_vote'@'localhost';
grant select on poll.Options to 'poll_vote'@'localhost';
grant select on poll.Polls to 'poll_vote'@'localhost';

create user 'poll_view'@'localhost' identified by 'SECRET'; -- FIXME
grant select on poll.Polls to 'poll_view'@'localhost';
grant select on poll.Options to 'poll_view'@'localhost';
grant select on poll.Tallies to 'poll_view'@'localhost';
